## START: Set by rpmautospec
## (rpmautospec version 0.6.0)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

Name:           bear
Version:        3.1.5
Release:        %autorelease
Summary:        Tool that generates a compilation database for clang tooling

License:        GPL-3.0-or-later
URL:            https://github.com/rizsotto/%{name}
Source:         %{url}/archive/%{version}/%{name}-%{version}.tar.gz

# https://fedoraproject.org/wiki/Changes/EncourageI686LeafRemoval
ExcludeArch:    %{ix86}

BuildRequires:  cmake
BuildRequires:  cmake(fmt)
BuildRequires:  cmake(gtest)
BuildRequires:  cmake(nlohmann_json)
BuildRequires:  cmake(spdlog)
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  gmock-devel
BuildRequires:  grpc-plugins
BuildRequires:  make
BuildRequires:  pkgconfig(protobuf)
BuildRequires:  pkgconfig(grpc++)
BuildRequires:  python3

# Needed for functional tests
BuildRequires:  python3dist(lit)
BuildRequires:  /usr/bin/more
BuildRequires:  /usr/bin/xargs
BuildRequires:  gcc-fortran
%ifarch %{valgrind_arches}
BuildRequires:  valgrind
%endif
BuildRequires:  fakeroot

# Work around RHBZ#1959600 (https://github.com/rizsotto/Bear/issues/309), which
# caused a test failure on s390x. It may only be happenstance that no other
# architectures were affected.
%global _lto_cflags %{nil}

%description
Build ear produces compilation database in JSON format. This database describes
how single compilation unit should be processed and can be used by Clang
tooling.

%prep
%autosetup -n Bear-%{version} -p1


%build
for f in $(ls test/bin/); do
    sed -i "s|^#\!/usr/bin/env\s\+python\s\?$|#!%{__python3}|" test/bin/$f
done
%ifarch s390x
# Dereferences a null pointer in some grpc routines; this is nontrivial to
# debug, but any assistance in investigating it is welcome. In case this is a
# grpc bug, we should check to see if this is fixed when grpc is updated.
#
# https://bugzilla.redhat.com/show_bug.cgi?id=2127458
rm -vf test/cases/intercept/valgrind/shell_commands_intercepted.sh
%endif

%cmake -DENABLE_FUNC_TESTS=ON -DENABLE_UNIT_TESTS=ON
%cmake_build

%install
%cmake_install

mv %{buildroot}/%{_docdir}/Bear %{buildroot}/%{_docdir}/bear

%check
# Tests run as part of build, because it's the same build target.
# There is no check target.


%files
%{_bindir}/bear
%{_libdir}/bear
%{_mandir}/man1/bear.1*
%{_mandir}/man1/bear-citnames.1*
%{_mandir}/man1/bear-intercept.1*

# rpmbuild on RHEL won't automatically pick up ChangeLog.md & README.md
%if 0%{?rhel}
%{_datadir}/doc/bear
%endif

%license COPYING
%doc %{_docdir}/bear

%changelog
## START: Generated by rpmautospec
* Wed Oct 09 2024 Dan Čermák <dan.cermak@cgc-instruments.com> - 3.1.5-1
- New upstream release 3.1.5, fixes rhbz#2315396

* Wed Jul 17 2024 Fedora Release Engineering <releng@fedoraproject.org> - 3.1.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Sun Jul 14 2024 Kefu Chai <tchaikov@gmail.com> - 3.1.4-2
- Apply patch for building with fmt 11 and Rebuilt for fmt 11

* Wed May 22 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 3.1.4-1
- Update to 3.1.4 (close RHBZ#2281447)

* Tue May 21 2024 František Zatloukal <fzatlouk@redhat.com> - 3.1.3-7
- Rebuilt for spdlog 1.14.1

* Sat Feb 24 2024 David Abdurachmanov <davidlt@rivosinc.com> - 3.1.3-6
- Properly check valgrind arches

* Sun Feb 04 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 3.1.3-5
- Rebuilt for abseil-cpp-20240116.0

* Tue Jan 23 2024 Fedora Release Engineering <releng@fedoraproject.org> - 3.1.3-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Jan 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 3.1.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Wed Jan 03 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 3.1.3-2
- F40+: Drop i686 support (leaf package)

* Wed Aug 30 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 3.1.3-1
- Update to 3.1.3 (close RHBZ#2235568)

* Tue Aug 29 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 3.1.2-6
- Rebuilt for abseil-cpp-20230802.0

* Wed Jul 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 3.1.2-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Sat Jul 08 2023 Vitaly Zaitsev <vitaly@easycoding.org> - 3.1.2-4
- Rebuilt due to spdlog 1.12 update.

* Wed Jun 28 2023 Vitaly Zaitsev <vitaly@easycoding.org> - 3.1.2-3
- Added upstream patch with fmt 10 fixes.

* Wed Jun 28 2023 Vitaly Zaitsev <vitaly@easycoding.org> - 3.1.2-2
- Rebuilt due to fmt 10 update.

* Sat Apr 22 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 3.1.2-1
- Update to 3.1.2 (close RHBZ#2188808)

* Sat Apr 15 2023 Florian Weimer <fweimer@redhat.com> - 3.1.1-3
- Port tests to C99

* Wed Mar 22 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 3.1.1-2
- Rebuild for abseil-cpp-20230125.1

* Mon Feb 20 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 3.1.1-1
- Update to 3.1.1 (close RHBZ#2169039)

* Wed Jan 18 2023 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.21-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Thu Dec 29 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.21-1
- Update to 3.0.21 (close RHBZ#2156922)

* Tue Nov 29 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.20-6
- Update License to SPDX

* Tue Nov 15 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.20-5
- Skip a failing valgrind test on s390x (close RHBZ#2127458, close
  RHBZ#2140814)

* Tue Nov 15 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.20-4
- Remove an obsolete comment from the spec file

* Thu Nov 03 2022 Vitaly Zaitsev <vitaly@easycoding.org> - 3.0.20-3
- Rebuilt due to spdlog update.

* Mon Aug 22 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.20-2
- Rebuilt for abseil-cpp 20220623.0 and grpc 1.48.0

* Sat Jul 23 2022 Dan Čermák <dan.cermak@cgc-instruments.com> - 3.0.20-1
- New upstream release 3.0.20
- drop workaround for fmt 9.0, patch has been merged upstream

* Wed Jul 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.19-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Tue Jul 12 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.19-3
- Rebuilt for fmt 9.0.0
- Define FMT_DEPRECATED_OSTREAM as a temporary workaround for API changes.

* Mon May 16 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.19-2
- Rebuild for grpc 1.46.1

* Wed Mar 23 2022 Dan Čermák <dan.cermak@cgc-instruments.com> - 3.0.19-1
- New upstream release 3.0.19, fixes rhbz#2066148

* Wed Mar 09 2022 Dan Čermák <dan.cermak@cgc-instruments.com> - 3.0.18-3
- Rebuild for abseil-cpp 20211102.0

* Wed Jan 19 2022 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.18-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Mon Jan 10 2022 Dan Čermák <dan.cermak@cgc-instruments.com> - 3.0.18-1
- New upstream release 3.0.18, fixes rhbz#2036416

* Mon Nov 22 2021 Dan Čermák <dan.cermak@cgc-instruments.com> - 3.0.17-1
- New upstream release 3.0.17, fixes rhbz#2023138

* Sat Nov 06 2021 Adrian Reber <adrian@lisas.de> - 3.0.16-2
- Rebuilt for protobuf 3.19.0

* Sat Nov 06 2021 Dan Čermák <dan.cermak@cgc-instruments.com> - 3.0.16-1
- New upstream release 3.0.16, fixes rhbz#2007711

* Sat Nov 06 2021 Dan Čermák <dan.cermak@cgc-instruments.com> - 3.0.15-6
- Enable unit tests & add optional test dependencies

* Fri Nov 05 2021 Adrian Reber <adrian@lisas.de> - 3.0.15-5
- Rebuilt for protobuf 3.19.0

* Sun Oct 24 2021 Adrian Reber <adrian@lisas.de> - 3.0.15-4
- Rebuilt for protobuf 3.18.1

* Thu Oct 07 2021 Dan Čermák <dan.cermak@cgc-instruments.com> - 3.0.15-3
- Rebuild for grpc 1.41

* Mon Sep 20 2021 Dan Čermák <dan.cermak@cgc-instruments.com> - 3.0.15-2
- Re-enable functional tests

* Mon Sep 20 2021 Dan Čermák <dan.cermak@cgc-instruments.com> - 3.0.15-1
- New upstream release 3.0.15, fixes rhbz#2002549

* Fri Sep 03 2021 Dan Čermák <dan.cermak@cgc-instruments.com> - 3.0.14-2
- Add forgotten source file

* Thu Sep 02 2021 Dan Čermák <dan.cermak@cgc-instruments.com> - 3.0.14-1
- New upstream release 3.0.14, Fixes rhbz#1999918

* Sun Aug 01 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.13-4
- Rebuild for grpc 1.39

* Wed Jul 21 2021 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.13-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Mon Jul 05 2021 Richard Shaw <hobbes1069@gmail.com> - 3.0.13-2
- Rebuild for new fmt version.

* Mon Jun 28 2021 Dan Čermák <dan.cermak@cgc-instruments.com> - 3.0.13-1
- New upstream release 3.0.13
- Fixes rhbz#1976681

* Tue Jun 01 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.12-1
- Update to 3.0.12
- Fixes rhbz#1966378
- Drop bear.libexec-subdir.patch, merged upstream in PR#348 and included in the
  current release

* Mon May 17 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 3.0.11-1
- Update to 3.0.11 (RHBZ#1921884)
- Drop bear.missing-includes.patch, which was upstreamed
- Rebase bear.libexec-subdir.patch from PR#348 as actually merged upstream
- Disable LTO to work around RHBZ#1959600
- Change pkgconfig(grpc) to pkgconfig(grpc++), and add pkgconfig(protobuf), to
  match the actual modules searched for in source/CMakeLists.txt

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.7-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Sun Jan 24 2021 Till Hofmann <thofmann@fedoraproject.org> - 3.0.7-1
- Update to 3.0.7

* Wed Dec 30 11:58:35 CET 2020 Till Hofmann <thofmann@fedoraproject.org> - 3.0.6-1
- Update to 3.0.6

* Sun Sep 13 2020 Dan Čermák <dan.cermak@cgc-instruments.com> - 2.4.4-1
- New upstream release 2.4.4 (rhbz#1877901)

* Mon Jul 27 2020 Fedora Release Engineering <releng@fedoraproject.org> - 2.4.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Tue Jan 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 2.4.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Sun Jan 26 2020 Dan Čermák <dan.cermak@cgc-instruments.com> - 2.4.3-1
- Bump version to 2.4.3

* Sun Sep  8 2019 Dan Čermák <dan.cermak@cgc-instruments.com> - 2.4.2-1
- Bump version to 2.4.2

* Wed Jul 31 2019 Wolfgang Stöggl <c72578@yahoo.de> - 2.4.1-1
- Bump version to 2.4.1
- Add %%{_datadir}/bash-completion/completions/bear to %%files

* Wed Jul 24 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.4.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Tue May 14 2019 Dan Čermák <dan.cermak@cgc-instruments.de> - 2.4.0-1
- Bump version to 2.4.0

* Thu Jan 31 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.3.13-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Jan 25 2019 Jonathan Wakely <jwakely@redhat.com> - 2.3.13-3
- Rebuilt for Boost 1.69

* Sat Nov 24 2018 Dan Čermák <dan.cermak@cgc-instruments.de> - 2.3.13-2
- Implement suggestions from Robert-André Mauchin and Till Hofmann

* Fri Oct  5 2018 Dan Čermák <dan.cermak@cgc-instruments.de> - 2.3.13-1
- Bump version to 2.3.13

* Tue Apr 10 2018 Dan Čermák <dan.cermak@cgc-instruments.de> 2.3.11-1
- Bump version to 2.3.11

* Thu Sep 03 2015 Pavel Odvody <podvody@redhat.com> 2.1.2-1.git15f4447
- new package built with tito

## END: Generated by rpmautospec
